//******************************************************************************
//* cet exemple met en vidence la puissance du langage SQL pour simuler une
//* relation maitre/dtail
//* utilisation simultanne des controls non orients donnes et orients donnes
//* utilisation de la proprit TabWidth d'un TlistBox
//* utilisation d'un module de donnes
//* utilisation de la proprit Align des TPanels
//* utilisation de l'alias DBDEMOS livr en standard avec Delphi
//* Cet exemple a t cris avec D5 entreprise il utilise les controls standards
//* vous pouvez m'envoyez vos remarques et commentaires  : julienraine@laetjr.com
//* suite possible :
//* utilisation des proprits Filter, Filtered d'une TTable
//* le fonctionnement tant trs similaire vous pouvez le mettre en oeuvre en
//* d'exercice.
//******************************************************************************
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, DBCtrls, ComCtrls, StdCtrls, ExtCtrls, ToolWin;

type
  TMainFrm = class(TForm)
    StatBmain: TStatusBar;
    TbMain: TToolBar;
    Pagauche: TPanel;
    Padroite: TPanel;
    LstNomEmp: TListBox;
    Label1: TLabel;
    CboFields: TComboBox;
    TbGauche: TToolButton;
    TbDroite: TToolButton;
    TbClose: TToolButton;
    ToolButton5: TToolButton;
    DBNavigator1: TDBNavigator;
    GridCommande: TDBGrid;
    GridItems: TDBGrid;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    procedure FormShow(Sender: TObject);
    procedure CboFieldsChange(Sender: TObject);
    procedure LstNomEmpClick(Sender: TObject);
    procedure TbCloseClick(Sender: TObject);
    procedure TbGaucheClick(Sender: TObject);
    procedure TbDroiteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    Procedure ChargeCbo;
    function ExtractNum(s: string):integer;
  public
    { Dclarations publiques }
  end;

var
  MainFrm: TMainFrm;

implementation

uses DMFrm;

{$R *.DFM}

//******************************************************************************
//* Chargement des noms de champs dans la Combo
//* fields[0] = N de l'employ
//*
//******************************************************************************
procedure TMainFrm.ChargeCbo;
var i : integer;
begin
     with Dm,CboFields.items do begin
       Clear;
      with TBlEmployes do begin
        if not(active) then open;
        for i := 1 to FieldCount -1 do
          Add(Fields[i].FieldName);
      end;
     end;
end;
//******************************************************************************
//*
//*
//*
//******************************************************************************
procedure TMainFrm.FormShow(Sender: TObject);
begin
     ChargeCbo;
end;
//******************************************************************************
//* chargement des valeurs en fonction du champ slectionn dans la combo
//*  on simule une relation maitre/dtail avec le N de l'employ comme champ
//*  commun
//******************************************************************************
procedure TMainFrm.CboFieldsChange(Sender: TObject);
var s : String;
begin
    if CBofields.ItemIndex > -1 then begin
     LstNomEmp.Items.Clear;
     S := CBoFields.Items[CBoFields.ItemIndex];
     with Dm.TblEmployes,lstNomEmp.Items do begin
       if not(active) then open;
       first;
       while not(eof) do begin
         Add(FieldByName(S).AsString + #9+ Fields[0].AsString);
         next;
       end;
     end;
     LstNomEmp.ItemIndex := 0;
     LstNomEmpClick(nil);
    end;
end;
//******************************************************************************
//* entre : Nom de l'employe + tab + N de l'employ
//* sortie : le N de lemploy
//* code d'erreur -1
//******************************************************************************
function TMainFrm.ExtractNum(s: string): integer;
var SubS : string;
begin
    if Pos(#9,s) > 0 then begin
       SubS := Copy(s,Pos(#9,s)+1,Length(s));
      try
          Result := StrToint(SubS);
      except
          Result:=-1;
      end;
    end;
end;
//******************************************************************************
//* Affiche les commandes en fonction du N de l'employ
//* on simule une relation maitre/dtail avec le N de l'employ comme champ
//*  commun
//******************************************************************************
procedure TMainFrm.LstNomEmpClick(Sender: TObject);
var NUmE : integer;
begin
    with DM, LstnomEmp do begin
    If ItemIndex > -1 then begin  // vrifie si un item est slectionn
     NumE := ExtractNum(Items[ItemIndex]);
     if numE > -1 then begin
      With QOrders do begin
       close;
       ParamByname('NumEmployee').value := NumE;
       Open;
      end;
     end;
    end;
     TblItems.Active := Qorders.Active;
    end;
end;
//******************************************************************************
//*  ferme l'aaplication
//*
//*
//******************************************************************************
procedure TMainFrm.TbCloseClick(Sender: TObject);
begin
     close;
end;
//******************************************************************************
//*  aligne le panel  gauche
//*
//*
//******************************************************************************
procedure TMainFrm.TbGaucheClick(Sender: TObject);
begin
     Pagauche.Align := alLeft;
end;
//******************************************************************************
//*  Aligne le panel  droite
//*
//*
//******************************************************************************
procedure TMainFrm.TbDroiteClick(Sender: TObject);
begin
     Pagauche.Align := alRight;
end;
//******************************************************************************
//* Extrait de l'aide en ligne de Delphi
//* Dfinissez la valeur de la proprit TabWidth pour contrler le nombre
//* d'units de bote de dialogue affich pour chaque caractre tabulation
//* apparaissant dans les chanes de la bote liste.
//* Si TabWidth a la valeur 0 (valeur par dfaut), les tabulations prennent
//* la valeur par dfaut spcifie par Windows, c'est--dire deux units de bote de dialogue.
//*
//*
//******************************************************************************
procedure TMainFrm.FormCreate(Sender: TObject);
begin
     LstNomEmp.TabWidth := 150;
end;
//******************************************************************************
//*   c'est fini
//*
//*
//******************************************************************************
end.
